/*******************************************************************************
* File Name: BUSACKn.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_BUSACKn_H) /* Pins BUSACKn_H */
#define CY_PINS_BUSACKn_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "BUSACKn_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 BUSACKn__PORT == 15 && ((BUSACKn__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    BUSACKn_Write(uint8 value);
void    BUSACKn_SetDriveMode(uint8 mode);
uint8   BUSACKn_ReadDataReg(void);
uint8   BUSACKn_Read(void);
void    BUSACKn_SetInterruptMode(uint16 position, uint16 mode);
uint8   BUSACKn_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the BUSACKn_SetDriveMode() function.
     *  @{
     */
        #define BUSACKn_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define BUSACKn_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define BUSACKn_DM_RES_UP          PIN_DM_RES_UP
        #define BUSACKn_DM_RES_DWN         PIN_DM_RES_DWN
        #define BUSACKn_DM_OD_LO           PIN_DM_OD_LO
        #define BUSACKn_DM_OD_HI           PIN_DM_OD_HI
        #define BUSACKn_DM_STRONG          PIN_DM_STRONG
        #define BUSACKn_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define BUSACKn_MASK               BUSACKn__MASK
#define BUSACKn_SHIFT              BUSACKn__SHIFT
#define BUSACKn_WIDTH              1u

/* Interrupt constants */
#if defined(BUSACKn__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in BUSACKn_SetInterruptMode() function.
     *  @{
     */
        #define BUSACKn_INTR_NONE      (uint16)(0x0000u)
        #define BUSACKn_INTR_RISING    (uint16)(0x0001u)
        #define BUSACKn_INTR_FALLING   (uint16)(0x0002u)
        #define BUSACKn_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define BUSACKn_INTR_MASK      (0x01u) 
#endif /* (BUSACKn__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define BUSACKn_PS                     (* (reg8 *) BUSACKn__PS)
/* Data Register */
#define BUSACKn_DR                     (* (reg8 *) BUSACKn__DR)
/* Port Number */
#define BUSACKn_PRT_NUM                (* (reg8 *) BUSACKn__PRT) 
/* Connect to Analog Globals */                                                  
#define BUSACKn_AG                     (* (reg8 *) BUSACKn__AG)                       
/* Analog MUX bux enable */
#define BUSACKn_AMUX                   (* (reg8 *) BUSACKn__AMUX) 
/* Bidirectional Enable */                                                        
#define BUSACKn_BIE                    (* (reg8 *) BUSACKn__BIE)
/* Bit-mask for Aliased Register Access */
#define BUSACKn_BIT_MASK               (* (reg8 *) BUSACKn__BIT_MASK)
/* Bypass Enable */
#define BUSACKn_BYP                    (* (reg8 *) BUSACKn__BYP)
/* Port wide control signals */                                                   
#define BUSACKn_CTL                    (* (reg8 *) BUSACKn__CTL)
/* Drive Modes */
#define BUSACKn_DM0                    (* (reg8 *) BUSACKn__DM0) 
#define BUSACKn_DM1                    (* (reg8 *) BUSACKn__DM1)
#define BUSACKn_DM2                    (* (reg8 *) BUSACKn__DM2) 
/* Input Buffer Disable Override */
#define BUSACKn_INP_DIS                (* (reg8 *) BUSACKn__INP_DIS)
/* LCD Common or Segment Drive */
#define BUSACKn_LCD_COM_SEG            (* (reg8 *) BUSACKn__LCD_COM_SEG)
/* Enable Segment LCD */
#define BUSACKn_LCD_EN                 (* (reg8 *) BUSACKn__LCD_EN)
/* Slew Rate Control */
#define BUSACKn_SLW                    (* (reg8 *) BUSACKn__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define BUSACKn_PRTDSI__CAPS_SEL       (* (reg8 *) BUSACKn__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define BUSACKn_PRTDSI__DBL_SYNC_IN    (* (reg8 *) BUSACKn__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define BUSACKn_PRTDSI__OE_SEL0        (* (reg8 *) BUSACKn__PRTDSI__OE_SEL0) 
#define BUSACKn_PRTDSI__OE_SEL1        (* (reg8 *) BUSACKn__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define BUSACKn_PRTDSI__OUT_SEL0       (* (reg8 *) BUSACKn__PRTDSI__OUT_SEL0) 
#define BUSACKn_PRTDSI__OUT_SEL1       (* (reg8 *) BUSACKn__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define BUSACKn_PRTDSI__SYNC_OUT       (* (reg8 *) BUSACKn__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(BUSACKn__SIO_CFG)
    #define BUSACKn_SIO_HYST_EN        (* (reg8 *) BUSACKn__SIO_HYST_EN)
    #define BUSACKn_SIO_REG_HIFREQ     (* (reg8 *) BUSACKn__SIO_REG_HIFREQ)
    #define BUSACKn_SIO_CFG            (* (reg8 *) BUSACKn__SIO_CFG)
    #define BUSACKn_SIO_DIFF           (* (reg8 *) BUSACKn__SIO_DIFF)
#endif /* (BUSACKn__SIO_CFG) */

/* Interrupt Registers */
#if defined(BUSACKn__INTSTAT)
    #define BUSACKn_INTSTAT            (* (reg8 *) BUSACKn__INTSTAT)
    #define BUSACKn_SNAP               (* (reg8 *) BUSACKn__SNAP)
    
	#define BUSACKn_0_INTTYPE_REG 		(* (reg8 *) BUSACKn__0__INTTYPE)
#endif /* (BUSACKn__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_BUSACKn_H */


/* [] END OF FILE */
