/*******************************************************************************
* File Name: HALTn.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_HALTn_H) /* Pins HALTn_H */
#define CY_PINS_HALTn_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "HALTn_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 HALTn__PORT == 15 && ((HALTn__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    HALTn_Write(uint8 value);
void    HALTn_SetDriveMode(uint8 mode);
uint8   HALTn_ReadDataReg(void);
uint8   HALTn_Read(void);
void    HALTn_SetInterruptMode(uint16 position, uint16 mode);
uint8   HALTn_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the HALTn_SetDriveMode() function.
     *  @{
     */
        #define HALTn_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define HALTn_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define HALTn_DM_RES_UP          PIN_DM_RES_UP
        #define HALTn_DM_RES_DWN         PIN_DM_RES_DWN
        #define HALTn_DM_OD_LO           PIN_DM_OD_LO
        #define HALTn_DM_OD_HI           PIN_DM_OD_HI
        #define HALTn_DM_STRONG          PIN_DM_STRONG
        #define HALTn_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define HALTn_MASK               HALTn__MASK
#define HALTn_SHIFT              HALTn__SHIFT
#define HALTn_WIDTH              1u

/* Interrupt constants */
#if defined(HALTn__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in HALTn_SetInterruptMode() function.
     *  @{
     */
        #define HALTn_INTR_NONE      (uint16)(0x0000u)
        #define HALTn_INTR_RISING    (uint16)(0x0001u)
        #define HALTn_INTR_FALLING   (uint16)(0x0002u)
        #define HALTn_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define HALTn_INTR_MASK      (0x01u) 
#endif /* (HALTn__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define HALTn_PS                     (* (reg8 *) HALTn__PS)
/* Data Register */
#define HALTn_DR                     (* (reg8 *) HALTn__DR)
/* Port Number */
#define HALTn_PRT_NUM                (* (reg8 *) HALTn__PRT) 
/* Connect to Analog Globals */                                                  
#define HALTn_AG                     (* (reg8 *) HALTn__AG)                       
/* Analog MUX bux enable */
#define HALTn_AMUX                   (* (reg8 *) HALTn__AMUX) 
/* Bidirectional Enable */                                                        
#define HALTn_BIE                    (* (reg8 *) HALTn__BIE)
/* Bit-mask for Aliased Register Access */
#define HALTn_BIT_MASK               (* (reg8 *) HALTn__BIT_MASK)
/* Bypass Enable */
#define HALTn_BYP                    (* (reg8 *) HALTn__BYP)
/* Port wide control signals */                                                   
#define HALTn_CTL                    (* (reg8 *) HALTn__CTL)
/* Drive Modes */
#define HALTn_DM0                    (* (reg8 *) HALTn__DM0) 
#define HALTn_DM1                    (* (reg8 *) HALTn__DM1)
#define HALTn_DM2                    (* (reg8 *) HALTn__DM2) 
/* Input Buffer Disable Override */
#define HALTn_INP_DIS                (* (reg8 *) HALTn__INP_DIS)
/* LCD Common or Segment Drive */
#define HALTn_LCD_COM_SEG            (* (reg8 *) HALTn__LCD_COM_SEG)
/* Enable Segment LCD */
#define HALTn_LCD_EN                 (* (reg8 *) HALTn__LCD_EN)
/* Slew Rate Control */
#define HALTn_SLW                    (* (reg8 *) HALTn__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define HALTn_PRTDSI__CAPS_SEL       (* (reg8 *) HALTn__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define HALTn_PRTDSI__DBL_SYNC_IN    (* (reg8 *) HALTn__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define HALTn_PRTDSI__OE_SEL0        (* (reg8 *) HALTn__PRTDSI__OE_SEL0) 
#define HALTn_PRTDSI__OE_SEL1        (* (reg8 *) HALTn__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define HALTn_PRTDSI__OUT_SEL0       (* (reg8 *) HALTn__PRTDSI__OUT_SEL0) 
#define HALTn_PRTDSI__OUT_SEL1       (* (reg8 *) HALTn__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define HALTn_PRTDSI__SYNC_OUT       (* (reg8 *) HALTn__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(HALTn__SIO_CFG)
    #define HALTn_SIO_HYST_EN        (* (reg8 *) HALTn__SIO_HYST_EN)
    #define HALTn_SIO_REG_HIFREQ     (* (reg8 *) HALTn__SIO_REG_HIFREQ)
    #define HALTn_SIO_CFG            (* (reg8 *) HALTn__SIO_CFG)
    #define HALTn_SIO_DIFF           (* (reg8 *) HALTn__SIO_DIFF)
#endif /* (HALTn__SIO_CFG) */

/* Interrupt Registers */
#if defined(HALTn__INTSTAT)
    #define HALTn_INTSTAT            (* (reg8 *) HALTn__INTSTAT)
    #define HALTn_SNAP               (* (reg8 *) HALTn__SNAP)
    
	#define HALTn_0_INTTYPE_REG 		(* (reg8 *) HALTn__0__INTTYPE)
#endif /* (HALTn__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_HALTn_H */


/* [] END OF FILE */
