/*******************************************************************************
* File Name: KbdReg_3_PM.c
* Version 1.80
*
* Description:
*  This file contains the setup, control, and status commands to support 
*  the component operation in the low power mode. 
*
* Note:
*
********************************************************************************
* Copyright 2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#include "KbdReg_3.h"

/* Check for removal by optimization */
#if !defined(KbdReg_3_Sync_ctrl_reg__REMOVED)

static KbdReg_3_BACKUP_STRUCT  KbdReg_3_backup = {0u};

    
/*******************************************************************************
* Function Name: KbdReg_3_SaveConfig
********************************************************************************
*
* Summary:
*  Saves the control register value.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void KbdReg_3_SaveConfig(void) 
{
    KbdReg_3_backup.controlState = KbdReg_3_Control;
}


/*******************************************************************************
* Function Name: KbdReg_3_RestoreConfig
********************************************************************************
*
* Summary:
*  Restores the control register value.
*
* Parameters:
*  None
*
* Return:
*  None
*
*
*******************************************************************************/
void KbdReg_3_RestoreConfig(void) 
{
     KbdReg_3_Control = KbdReg_3_backup.controlState;
}


/*******************************************************************************
* Function Name: KbdReg_3_Sleep
********************************************************************************
*
* Summary:
*  Prepares the component for entering the low power mode.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void KbdReg_3_Sleep(void) 
{
    KbdReg_3_SaveConfig();
}


/*******************************************************************************
* Function Name: KbdReg_3_Wakeup
********************************************************************************
*
* Summary:
*  Restores the component after waking up from the low power mode.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void KbdReg_3_Wakeup(void)  
{
    KbdReg_3_RestoreConfig();
}

#endif /* End check for removal by optimization */


/* [] END OF FILE */
