/*******************************************************************************
* File Name: RDn.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_RDn_H) /* Pins RDn_H */
#define CY_PINS_RDn_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "RDn_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 RDn__PORT == 15 && ((RDn__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    RDn_Write(uint8 value);
void    RDn_SetDriveMode(uint8 mode);
uint8   RDn_ReadDataReg(void);
uint8   RDn_Read(void);
void    RDn_SetInterruptMode(uint16 position, uint16 mode);
uint8   RDn_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the RDn_SetDriveMode() function.
     *  @{
     */
        #define RDn_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define RDn_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define RDn_DM_RES_UP          PIN_DM_RES_UP
        #define RDn_DM_RES_DWN         PIN_DM_RES_DWN
        #define RDn_DM_OD_LO           PIN_DM_OD_LO
        #define RDn_DM_OD_HI           PIN_DM_OD_HI
        #define RDn_DM_STRONG          PIN_DM_STRONG
        #define RDn_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define RDn_MASK               RDn__MASK
#define RDn_SHIFT              RDn__SHIFT
#define RDn_WIDTH              1u

/* Interrupt constants */
#if defined(RDn__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in RDn_SetInterruptMode() function.
     *  @{
     */
        #define RDn_INTR_NONE      (uint16)(0x0000u)
        #define RDn_INTR_RISING    (uint16)(0x0001u)
        #define RDn_INTR_FALLING   (uint16)(0x0002u)
        #define RDn_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define RDn_INTR_MASK      (0x01u) 
#endif /* (RDn__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define RDn_PS                     (* (reg8 *) RDn__PS)
/* Data Register */
#define RDn_DR                     (* (reg8 *) RDn__DR)
/* Port Number */
#define RDn_PRT_NUM                (* (reg8 *) RDn__PRT) 
/* Connect to Analog Globals */                                                  
#define RDn_AG                     (* (reg8 *) RDn__AG)                       
/* Analog MUX bux enable */
#define RDn_AMUX                   (* (reg8 *) RDn__AMUX) 
/* Bidirectional Enable */                                                        
#define RDn_BIE                    (* (reg8 *) RDn__BIE)
/* Bit-mask for Aliased Register Access */
#define RDn_BIT_MASK               (* (reg8 *) RDn__BIT_MASK)
/* Bypass Enable */
#define RDn_BYP                    (* (reg8 *) RDn__BYP)
/* Port wide control signals */                                                   
#define RDn_CTL                    (* (reg8 *) RDn__CTL)
/* Drive Modes */
#define RDn_DM0                    (* (reg8 *) RDn__DM0) 
#define RDn_DM1                    (* (reg8 *) RDn__DM1)
#define RDn_DM2                    (* (reg8 *) RDn__DM2) 
/* Input Buffer Disable Override */
#define RDn_INP_DIS                (* (reg8 *) RDn__INP_DIS)
/* LCD Common or Segment Drive */
#define RDn_LCD_COM_SEG            (* (reg8 *) RDn__LCD_COM_SEG)
/* Enable Segment LCD */
#define RDn_LCD_EN                 (* (reg8 *) RDn__LCD_EN)
/* Slew Rate Control */
#define RDn_SLW                    (* (reg8 *) RDn__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define RDn_PRTDSI__CAPS_SEL       (* (reg8 *) RDn__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define RDn_PRTDSI__DBL_SYNC_IN    (* (reg8 *) RDn__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define RDn_PRTDSI__OE_SEL0        (* (reg8 *) RDn__PRTDSI__OE_SEL0) 
#define RDn_PRTDSI__OE_SEL1        (* (reg8 *) RDn__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define RDn_PRTDSI__OUT_SEL0       (* (reg8 *) RDn__PRTDSI__OUT_SEL0) 
#define RDn_PRTDSI__OUT_SEL1       (* (reg8 *) RDn__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define RDn_PRTDSI__SYNC_OUT       (* (reg8 *) RDn__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(RDn__SIO_CFG)
    #define RDn_SIO_HYST_EN        (* (reg8 *) RDn__SIO_HYST_EN)
    #define RDn_SIO_REG_HIFREQ     (* (reg8 *) RDn__SIO_REG_HIFREQ)
    #define RDn_SIO_CFG            (* (reg8 *) RDn__SIO_CFG)
    #define RDn_SIO_DIFF           (* (reg8 *) RDn__SIO_DIFF)
#endif /* (RDn__SIO_CFG) */

/* Interrupt Registers */
#if defined(RDn__INTSTAT)
    #define RDn_INTSTAT            (* (reg8 *) RDn__INTSTAT)
    #define RDn_SNAP               (* (reg8 *) RDn__SNAP)
    
	#define RDn_0_INTTYPE_REG 		(* (reg8 *) RDn__0__INTTYPE)
#endif /* (RDn__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_RDn_H */


/* [] END OF FILE */
