/*******************************************************************************
* File Name: WAITn.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_WAITn_H) /* Pins WAITn_H */
#define CY_PINS_WAITn_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "WAITn_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 WAITn__PORT == 15 && ((WAITn__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    WAITn_Write(uint8 value);
void    WAITn_SetDriveMode(uint8 mode);
uint8   WAITn_ReadDataReg(void);
uint8   WAITn_Read(void);
void    WAITn_SetInterruptMode(uint16 position, uint16 mode);
uint8   WAITn_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the WAITn_SetDriveMode() function.
     *  @{
     */
        #define WAITn_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define WAITn_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define WAITn_DM_RES_UP          PIN_DM_RES_UP
        #define WAITn_DM_RES_DWN         PIN_DM_RES_DWN
        #define WAITn_DM_OD_LO           PIN_DM_OD_LO
        #define WAITn_DM_OD_HI           PIN_DM_OD_HI
        #define WAITn_DM_STRONG          PIN_DM_STRONG
        #define WAITn_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define WAITn_MASK               WAITn__MASK
#define WAITn_SHIFT              WAITn__SHIFT
#define WAITn_WIDTH              1u

/* Interrupt constants */
#if defined(WAITn__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in WAITn_SetInterruptMode() function.
     *  @{
     */
        #define WAITn_INTR_NONE      (uint16)(0x0000u)
        #define WAITn_INTR_RISING    (uint16)(0x0001u)
        #define WAITn_INTR_FALLING   (uint16)(0x0002u)
        #define WAITn_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define WAITn_INTR_MASK      (0x01u) 
#endif /* (WAITn__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define WAITn_PS                     (* (reg8 *) WAITn__PS)
/* Data Register */
#define WAITn_DR                     (* (reg8 *) WAITn__DR)
/* Port Number */
#define WAITn_PRT_NUM                (* (reg8 *) WAITn__PRT) 
/* Connect to Analog Globals */                                                  
#define WAITn_AG                     (* (reg8 *) WAITn__AG)                       
/* Analog MUX bux enable */
#define WAITn_AMUX                   (* (reg8 *) WAITn__AMUX) 
/* Bidirectional Enable */                                                        
#define WAITn_BIE                    (* (reg8 *) WAITn__BIE)
/* Bit-mask for Aliased Register Access */
#define WAITn_BIT_MASK               (* (reg8 *) WAITn__BIT_MASK)
/* Bypass Enable */
#define WAITn_BYP                    (* (reg8 *) WAITn__BYP)
/* Port wide control signals */                                                   
#define WAITn_CTL                    (* (reg8 *) WAITn__CTL)
/* Drive Modes */
#define WAITn_DM0                    (* (reg8 *) WAITn__DM0) 
#define WAITn_DM1                    (* (reg8 *) WAITn__DM1)
#define WAITn_DM2                    (* (reg8 *) WAITn__DM2) 
/* Input Buffer Disable Override */
#define WAITn_INP_DIS                (* (reg8 *) WAITn__INP_DIS)
/* LCD Common or Segment Drive */
#define WAITn_LCD_COM_SEG            (* (reg8 *) WAITn__LCD_COM_SEG)
/* Enable Segment LCD */
#define WAITn_LCD_EN                 (* (reg8 *) WAITn__LCD_EN)
/* Slew Rate Control */
#define WAITn_SLW                    (* (reg8 *) WAITn__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define WAITn_PRTDSI__CAPS_SEL       (* (reg8 *) WAITn__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define WAITn_PRTDSI__DBL_SYNC_IN    (* (reg8 *) WAITn__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define WAITn_PRTDSI__OE_SEL0        (* (reg8 *) WAITn__PRTDSI__OE_SEL0) 
#define WAITn_PRTDSI__OE_SEL1        (* (reg8 *) WAITn__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define WAITn_PRTDSI__OUT_SEL0       (* (reg8 *) WAITn__PRTDSI__OUT_SEL0) 
#define WAITn_PRTDSI__OUT_SEL1       (* (reg8 *) WAITn__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define WAITn_PRTDSI__SYNC_OUT       (* (reg8 *) WAITn__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(WAITn__SIO_CFG)
    #define WAITn_SIO_HYST_EN        (* (reg8 *) WAITn__SIO_HYST_EN)
    #define WAITn_SIO_REG_HIFREQ     (* (reg8 *) WAITn__SIO_REG_HIFREQ)
    #define WAITn_SIO_CFG            (* (reg8 *) WAITn__SIO_CFG)
    #define WAITn_SIO_DIFF           (* (reg8 *) WAITn__SIO_DIFF)
#endif /* (WAITn__SIO_CFG) */

/* Interrupt Registers */
#if defined(WAITn__INTSTAT)
    #define WAITn_INTSTAT            (* (reg8 *) WAITn__INTSTAT)
    #define WAITn_SNAP               (* (reg8 *) WAITn__SNAP)
    
	#define WAITn_0_INTTYPE_REG 		(* (reg8 *) WAITn__0__INTTYPE)
#endif /* (WAITn__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_WAITn_H */


/* [] END OF FILE */
