/*******************************************************************************
* File Name: WRn.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_WRn_H) /* Pins WRn_H */
#define CY_PINS_WRn_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "WRn_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 WRn__PORT == 15 && ((WRn__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    WRn_Write(uint8 value);
void    WRn_SetDriveMode(uint8 mode);
uint8   WRn_ReadDataReg(void);
uint8   WRn_Read(void);
void    WRn_SetInterruptMode(uint16 position, uint16 mode);
uint8   WRn_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the WRn_SetDriveMode() function.
     *  @{
     */
        #define WRn_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define WRn_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define WRn_DM_RES_UP          PIN_DM_RES_UP
        #define WRn_DM_RES_DWN         PIN_DM_RES_DWN
        #define WRn_DM_OD_LO           PIN_DM_OD_LO
        #define WRn_DM_OD_HI           PIN_DM_OD_HI
        #define WRn_DM_STRONG          PIN_DM_STRONG
        #define WRn_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define WRn_MASK               WRn__MASK
#define WRn_SHIFT              WRn__SHIFT
#define WRn_WIDTH              1u

/* Interrupt constants */
#if defined(WRn__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in WRn_SetInterruptMode() function.
     *  @{
     */
        #define WRn_INTR_NONE      (uint16)(0x0000u)
        #define WRn_INTR_RISING    (uint16)(0x0001u)
        #define WRn_INTR_FALLING   (uint16)(0x0002u)
        #define WRn_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define WRn_INTR_MASK      (0x01u) 
#endif /* (WRn__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define WRn_PS                     (* (reg8 *) WRn__PS)
/* Data Register */
#define WRn_DR                     (* (reg8 *) WRn__DR)
/* Port Number */
#define WRn_PRT_NUM                (* (reg8 *) WRn__PRT) 
/* Connect to Analog Globals */                                                  
#define WRn_AG                     (* (reg8 *) WRn__AG)                       
/* Analog MUX bux enable */
#define WRn_AMUX                   (* (reg8 *) WRn__AMUX) 
/* Bidirectional Enable */                                                        
#define WRn_BIE                    (* (reg8 *) WRn__BIE)
/* Bit-mask for Aliased Register Access */
#define WRn_BIT_MASK               (* (reg8 *) WRn__BIT_MASK)
/* Bypass Enable */
#define WRn_BYP                    (* (reg8 *) WRn__BYP)
/* Port wide control signals */                                                   
#define WRn_CTL                    (* (reg8 *) WRn__CTL)
/* Drive Modes */
#define WRn_DM0                    (* (reg8 *) WRn__DM0) 
#define WRn_DM1                    (* (reg8 *) WRn__DM1)
#define WRn_DM2                    (* (reg8 *) WRn__DM2) 
/* Input Buffer Disable Override */
#define WRn_INP_DIS                (* (reg8 *) WRn__INP_DIS)
/* LCD Common or Segment Drive */
#define WRn_LCD_COM_SEG            (* (reg8 *) WRn__LCD_COM_SEG)
/* Enable Segment LCD */
#define WRn_LCD_EN                 (* (reg8 *) WRn__LCD_EN)
/* Slew Rate Control */
#define WRn_SLW                    (* (reg8 *) WRn__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define WRn_PRTDSI__CAPS_SEL       (* (reg8 *) WRn__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define WRn_PRTDSI__DBL_SYNC_IN    (* (reg8 *) WRn__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define WRn_PRTDSI__OE_SEL0        (* (reg8 *) WRn__PRTDSI__OE_SEL0) 
#define WRn_PRTDSI__OE_SEL1        (* (reg8 *) WRn__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define WRn_PRTDSI__OUT_SEL0       (* (reg8 *) WRn__PRTDSI__OUT_SEL0) 
#define WRn_PRTDSI__OUT_SEL1       (* (reg8 *) WRn__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define WRn_PRTDSI__SYNC_OUT       (* (reg8 *) WRn__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(WRn__SIO_CFG)
    #define WRn_SIO_HYST_EN        (* (reg8 *) WRn__SIO_HYST_EN)
    #define WRn_SIO_REG_HIFREQ     (* (reg8 *) WRn__SIO_REG_HIFREQ)
    #define WRn_SIO_CFG            (* (reg8 *) WRn__SIO_CFG)
    #define WRn_SIO_DIFF           (* (reg8 *) WRn__SIO_DIFF)
#endif /* (WRn__SIO_CFG) */

/* Interrupt Registers */
#if defined(WRn__INTSTAT)
    #define WRn_INTSTAT            (* (reg8 *) WRn__INTSTAT)
    #define WRn_SNAP               (* (reg8 *) WRn__SNAP)
    
	#define WRn_0_INTTYPE_REG 		(* (reg8 *) WRn__0__INTTYPE)
#endif /* (WRn__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_WRn_H */


/* [] END OF FILE */
