
#include "project.h"

#include "common.h"

/* Defines for DMA_1 */
#define DMA_1_BYTES_PER_BURST 2
#define DMA_1_REQUEST_PER_BURST 1
#define DMA_1_SRC_BASE (CYDEV_SRAM_BASE)
#define DMA_1_DST_BASE (CYDEV_PERIPH_BASE)

/* Variable declarations for DMA_1 */
/* Move these variable declarations to the top of the function */
uint8 DMA_1_Chan;
uint8 DMA_1_TD[1];

uint8 scr1_buf[8][80],scr2_buf[8][80];
uint8 *cur_scr,*next_scr;
uint8 next_line=0;

extern uint8 zxvideo[];
extern uint8 zxfont[][8];

//#define VGA_DEBUG(a)  GP5_5_Write(a);
#define VGA_DEBUG(a) 

CY_ISR_PROTO(HsyncISR)
{
    uint16 vert;
    
    VGA_DEBUG(1);
    
    vert=*VSyncCtrl_1_Datapath_1_A0_PTR;
    
    if (vert>19)
    {
      uint8 i,j,c;
      uint32 l;
        
      i=(499-vert)&7;
      CyDmaTdSetAddress(DMA_1_TD[0], LO16((uint32)cur_scr+i*80),
       LO16((uint32)shifter16_1_Datapath_1_u0__16BIT_F0_REG));
      CyDmaChEnable(DMA_1_Chan,1);

      uint8 *sptr,*fptr,*wptr;

      wptr=next_scr+i;
      if (next_line<24) 
      {
       sptr=zxvideo+256*next_line+i;
       for(j=0;j<4;j++)
       {
        c=*sptr;
        fptr=zxfont[c];
#if 1
        l=*(uint32 *)fptr;
        wptr[  0]=l&0xFF; wptr[ 80]=(l&0xFF00)>>8; wptr[160]=(l&0xFF0000)>>16; wptr[240]=(l&0xFF000000)>>24;
        l=*(uint32 *)(fptr+4);
        wptr[320]=l&0xFF; wptr[400]=(l&0xFF00)>>8; wptr[480]=(l&0xFF0000)>>16; wptr[560]=(l&0xFF000000)>>24; 
#else
        wptr[  0]=*fptr++; wptr[ 80]=*fptr++; wptr[160]=*fptr++; wptr[240]=*fptr++;
        wptr[320]=*fptr++; wptr[400]=*fptr++; wptr[480]=*fptr++; wptr[560]=*fptr; 
#endif    
        wptr+=8; sptr+=8;
       }
      }
      else
      {
        for(j=0;j<4;j++) {
            wptr[0]=wptr[80]=wptr[160]=wptr[240]=0;
            wptr[320]=wptr[400]=wptr[480]=wptr[560]=0;
            wptr+=8;
        }
      }
      if (i==7) {
                 uint8 *tmp_ptr;
                 next_line++; if (next_line>59) next_line=0;
                 tmp_ptr=cur_scr;
                 cur_scr=next_scr;
                 next_scr=tmp_ptr;
                }
    }
    else
    {
      next_line=1;
    }
    
    VGA_DEBUG(0);
}

void vga_init(void)
{
    int i,j;
    

    VSyncCtrl_1_Sync_Start();
    SyncCtrl_1_Sync_Start();
    shifter16_1_Count7_1_Start();
    
    cur_scr=scr1_buf[0];
    next_scr=scr2_buf[0];
    
    DMA_1_Chan = DMA_1_DmaInitialize(DMA_1_BYTES_PER_BURST, DMA_1_REQUEST_PER_BURST, 
        HI16(DMA_1_SRC_BASE), HI16(DMA_1_DST_BASE));
    DMA_1_TD[0] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_1_TD[0], 80, CY_DMA_DISABLE_TD,
      CY_DMA_TD_INC_SRC_ADR|DMA_1__TD_TERMOUT_EN);
    CyDmaTdSetAddress(DMA_1_TD[0], LO16((uint32)scr1_buf[0]),
      LO16((uint32)shifter16_1_Datapath_1_u0__16BIT_F0_REG));
    CyDmaChSetInitialTd(DMA_1_Chan, DMA_1_TD[0]);
    CyDmaChEnable(DMA_1_Chan,1);

    isr_1_StartEx(HsyncISR);
}

/* [] END OF FILE */
