#include "common.h"

volatile uint8 dmaline=0;
uint8 zxvideo[32*192];          // HighRes ready ???

/* Defines for DMA_2 */
#define DMA_2_BYTES_PER_BURST 1
#define DMA_2_REQUEST_PER_BURST 1
#define DMA_2_SRC_BASE (CYDEV_PERIPH_BASE)
#define DMA_2_DST_BASE (CYDEV_SRAM_BASE)

/* Variable declarations for DMA_2 */
/* Move these variable declarations to the top of the function */
uint8 DMA_2_Chan;
uint8 DMA_2_TD[1];

volatile uint8 dmadone=0;

CY_ISR_PROTO(vsyncint)
{
 if (dmaline)
 {   
 dmaline=0;
 CyDmaChSetRequest(DMA_2_Chan, CY_DMA_CPU_TERM_CHAIN);
 CyDmaTdSetAddress(DMA_2_TD[0], LO16((uint32)FIFOIn_1_FIFO_PTR), LO16((uint32)zxvideo));
 CyDmaChEnable(DMA_2_Chan, 1);   
 }
}

CY_ISR_PROTO(dmaint)
{   
    if (dmaline<192) 
    {dmaline++;
     CyDmaTdSetAddress(DMA_2_TD[0], LO16((uint32)FIFOIn_1_FIFO_PTR), LO16((uint32)(zxvideo+32*dmaline)));
     CyDmaChEnable(DMA_2_Chan, 1);   
    }
}    

// D-FILE is executed with bit 15 set => at address >0xc000

void ZX81ModeLoop(void)
{
    uint8 i,j;
    uint8 buf[64];
    char *tbuf,*pbuf;
        
    // CLK driven by DR, not by hardware Clock_1 (Clock_1_Stop useless ?)
    //Clock_1_Stop();   
    //*(uint8*)CYREG_PRT12_BYP&=~0x20;         // CLK on P12[5]
 
    ink=0;key=0;ubuf=wbuf;pbuf=rbuf;uptr=0;

    CyDelay(1);RESETn_Write(1);
    do
    {        
#if 0
        //status("DMA2",(uint8)CyDmaChStatus(DMA_2_Chan,NULL,NULL));
        //status("FIFO",(uint8)FIFOIn_1_ReadStatus());
        sprintf(buffer,"%3d   \r",dmaline); while (!USBUART_CDCIsReady()) {;} USBUART_PutString(buffer);

        if (dmaline==192)
        {
            for(i=180;i<192;i++)
             { 
                sprintf(buffer,"%4d: ",i*32); while (!USBUART_CDCIsReady()) {;} USBUART_PutString(buffer);
                for(j=0;j<32;j++)
                 {sprintf(buffer,"%02x",zxvideo[i*32+j]); while (!USBUART_CDCIsReady()) {;} USBUART_PutString(buffer);}
                sprintf(buffer,"\n\r"); while (!USBUART_CDCIsReady()) {;} USBUART_PutString(buffer);
             }
        }
#endif        
        if (uptr&&USBUART_CDCIsReady()) {//IOint_Disable();
                                         ubuf[uptr]=0;
                                         tbuf=ubuf;ubuf=pbuf;pbuf=tbuf;
                                         uptr=0;
                                         //IOint_Enable();
                                         uprintf(pbuf);}

        if ((i=USBUART_GetCount())) {USBUART_GetData(buf,i);ink=1; key=buf[0];}
        
        if (zxps2_available())
        {
         key=zxps2_read();
         // Shift ?
         if (key&0x80) { KbdReg_0_Write(0x1E); }
         // A15=0
         if ((key&0x7F)==' ') { KbdReg_7_Write(0x1E); CyDelay(100); KbdReg_7_Write(0x1F); }
         if ((key&0x7F)=='.') { KbdReg_7_Write(0x1D); CyDelay(100); KbdReg_7_Write(0x1F); }
         if ((key&0x7F)=='m') { KbdReg_7_Write(0x1B); CyDelay(100); KbdReg_7_Write(0x1F); }
         if ((key&0x7F)=='n') { KbdReg_7_Write(0x17); CyDelay(100); KbdReg_7_Write(0x1F); }
         if ((key&0x7F)=='b') { KbdReg_7_Write(0x0F); CyDelay(100); KbdReg_7_Write(0x1F); }
         // A14=0
         if ((key&0x7F)==13)  { KbdReg_6_Write(0x1E); CyDelay(100); KbdReg_6_Write(0x1F); }
         if ((key&0x7F)=='l') { KbdReg_6_Write(0x1D); CyDelay(100); KbdReg_6_Write(0x1F); }
         if ((key&0x7F)=='k') { KbdReg_6_Write(0x1B); CyDelay(100); KbdReg_6_Write(0x1F); }
         if ((key&0x7F)=='j') { KbdReg_6_Write(0x17); CyDelay(100); KbdReg_6_Write(0x1F); }
         if ((key&0x7F)=='h') { KbdReg_6_Write(0x0F); CyDelay(100); KbdReg_6_Write(0x1F); }
         // A13=0
         if ((key&0x7F)=='p') { KbdReg_5_Write(0x1E); CyDelay(100); KbdReg_5_Write(0x1F); }
         if ((key&0x7F)=='o') { KbdReg_5_Write(0x1D); CyDelay(100); KbdReg_5_Write(0x1F); }
         if ((key&0x7F)=='i') { KbdReg_5_Write(0x1B); CyDelay(100); KbdReg_5_Write(0x1F); }
         if ((key&0x7F)=='u') { KbdReg_5_Write(0x17); CyDelay(100); KbdReg_5_Write(0x1F); }
         if ((key&0x7F)=='y') { KbdReg_5_Write(0x0F); CyDelay(100); KbdReg_5_Write(0x1F); }
         // A12=0
         if ((key&0x7F)=='0') { KbdReg_4_Write(0x1E); CyDelay(100); KbdReg_4_Write(0x1F); }
         if ((key&0x7F)=='9') { KbdReg_4_Write(0x1D); CyDelay(100); KbdReg_4_Write(0x1F); }
         if ((key&0x7F)=='8') { KbdReg_4_Write(0x1B); CyDelay(100); KbdReg_4_Write(0x1F); }
         if ((key&0x7F)=='7') { KbdReg_4_Write(0x17); CyDelay(100); KbdReg_4_Write(0x1F); }
         if ((key&0x7F)=='6') { KbdReg_4_Write(0x0F); CyDelay(100); KbdReg_4_Write(0x1F); }
         // A11=0
         if ((key&0x7F)=='1') { KbdReg_3_Write(0x1E); CyDelay(100); KbdReg_3_Write(0x1F); }
         if ((key&0x7F)=='2') { KbdReg_3_Write(0x1D); CyDelay(100); KbdReg_3_Write(0x1F); }
         if ((key&0x7F)=='3') { KbdReg_3_Write(0x1B); CyDelay(100); KbdReg_3_Write(0x1F); }
         if ((key&0x7F)=='4') { KbdReg_3_Write(0x17); CyDelay(100); KbdReg_3_Write(0x1F); }
         if ((key&0x7F)=='5') { KbdReg_3_Write(0x0F); CyDelay(100); KbdReg_3_Write(0x1F); }
         // A10=0
         if ((key&0x7F)=='q') { KbdReg_2_Write(0x1E); CyDelay(100); KbdReg_2_Write(0x1F); }
         if ((key&0x7F)=='w') { KbdReg_2_Write(0x1D); CyDelay(100); KbdReg_2_Write(0x1F); }
         if ((key&0x7F)=='e') { KbdReg_2_Write(0x1B); CyDelay(100); KbdReg_2_Write(0x1F); }
         if ((key&0x7F)=='r') { KbdReg_2_Write(0x17); CyDelay(100); KbdReg_2_Write(0x1F); }
         if ((key&0x7F)=='t') { KbdReg_2_Write(0x0F); CyDelay(100); KbdReg_2_Write(0x1F); }
         // A9=0
         if ((key&0x7F)=='a') { KbdReg_1_Write(0x1E); CyDelay(100); KbdReg_1_Write(0x1F); }
         if ((key&0x7F)=='s') { KbdReg_1_Write(0x1D); CyDelay(100); KbdReg_1_Write(0x1F); }
         if ((key&0x7F)=='d') { KbdReg_1_Write(0x1B); CyDelay(100); KbdReg_1_Write(0x1F); }
         if ((key&0x7F)=='f') { KbdReg_1_Write(0x17); CyDelay(100); KbdReg_1_Write(0x1F); }
         if ((key&0x7F)=='g') { KbdReg_1_Write(0x0F); CyDelay(100); KbdReg_1_Write(0x1F); }
         // A8=0
         //if ((key&0x7F)=='?') { KbdReg_1_Write(0x1E); CyDelay(100); KbdReg_1_Write(0x1F); }
         if ((key&0x7F)=='z') { KbdReg_0_Write(0x1D-(key>>7)); CyDelay(100); KbdReg_0_Write(0x1F); }
         if ((key&0x7F)=='x') { KbdReg_0_Write(0x1B-(key>>7)); CyDelay(100); KbdReg_0_Write(0x1F); }
         if ((key&0x7F)=='c') { KbdReg_0_Write(0x17-(key>>7)); CyDelay(100); KbdReg_0_Write(0x1F); }
         if ((key&0x7F)=='v') { KbdReg_0_Write(0x0F-(key>>7)); CyDelay(100); KbdReg_0_Write(0x1F); }
        // Release Shift
         if (key&0x80) { KbdReg_0_Write(0x1F); }
        }
    } while (key!='~');
}

void ZX81ModeInit(void)
{

/* DMA Configuration for DMA_2 */
 DMA_2_Chan = DMA_2_DmaInitialize(DMA_2_BYTES_PER_BURST, DMA_2_REQUEST_PER_BURST, 
    HI16(DMA_2_SRC_BASE), HI16(DMA_2_DST_BASE));
 DMA_2_TD[0] = CyDmaTdAllocate();
 CyDmaTdSetConfiguration(DMA_2_TD[0], 32, CY_DMA_DISABLE_TD, DMA_2__TD_TERMOUT_EN | CY_DMA_TD_INC_DST_ADR);
 CyDmaTdSetAddress(DMA_2_TD[0], LO16((uint32)FIFOIn_1_FIFO_PTR), LO16((uint32)(zxvideo+0)));
 CyDmaChSetInitialTd(DMA_2_Chan, DMA_2_TD[0]);
 CyDmaChEnable(DMA_2_Chan, 1);

 zxdma_int_StartEx(dmaint);
 inFE_int_StartEx(vsyncint);
    
 FIFOIn_1_Start();

 ZX81ModeLoop();
}