/*******************************************************************************
* File Name: Al.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Al_H) /* Pins Al_H */
#define CY_PINS_Al_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Al_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Al__PORT == 15 && ((Al__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    Al_Write(uint8 value);
void    Al_SetDriveMode(uint8 mode);
uint8   Al_ReadDataReg(void);
uint8   Al_Read(void);
void    Al_SetInterruptMode(uint16 position, uint16 mode);
uint8   Al_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the Al_SetDriveMode() function.
     *  @{
     */
        #define Al_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define Al_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define Al_DM_RES_UP          PIN_DM_RES_UP
        #define Al_DM_RES_DWN         PIN_DM_RES_DWN
        #define Al_DM_OD_LO           PIN_DM_OD_LO
        #define Al_DM_OD_HI           PIN_DM_OD_HI
        #define Al_DM_STRONG          PIN_DM_STRONG
        #define Al_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define Al_MASK               Al__MASK
#define Al_SHIFT              Al__SHIFT
#define Al_WIDTH              8u

/* Interrupt constants */
#if defined(Al__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in Al_SetInterruptMode() function.
     *  @{
     */
        #define Al_INTR_NONE      (uint16)(0x0000u)
        #define Al_INTR_RISING    (uint16)(0x0001u)
        #define Al_INTR_FALLING   (uint16)(0x0002u)
        #define Al_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define Al_INTR_MASK      (0x01u) 
#endif /* (Al__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Al_PS                     (* (reg8 *) Al__PS)
/* Data Register */
#define Al_DR                     (* (reg8 *) Al__DR)
/* Port Number */
#define Al_PRT_NUM                (* (reg8 *) Al__PRT) 
/* Connect to Analog Globals */                                                  
#define Al_AG                     (* (reg8 *) Al__AG)                       
/* Analog MUX bux enable */
#define Al_AMUX                   (* (reg8 *) Al__AMUX) 
/* Bidirectional Enable */                                                        
#define Al_BIE                    (* (reg8 *) Al__BIE)
/* Bit-mask for Aliased Register Access */
#define Al_BIT_MASK               (* (reg8 *) Al__BIT_MASK)
/* Bypass Enable */
#define Al_BYP                    (* (reg8 *) Al__BYP)
/* Port wide control signals */                                                   
#define Al_CTL                    (* (reg8 *) Al__CTL)
/* Drive Modes */
#define Al_DM0                    (* (reg8 *) Al__DM0) 
#define Al_DM1                    (* (reg8 *) Al__DM1)
#define Al_DM2                    (* (reg8 *) Al__DM2) 
/* Input Buffer Disable Override */
#define Al_INP_DIS                (* (reg8 *) Al__INP_DIS)
/* LCD Common or Segment Drive */
#define Al_LCD_COM_SEG            (* (reg8 *) Al__LCD_COM_SEG)
/* Enable Segment LCD */
#define Al_LCD_EN                 (* (reg8 *) Al__LCD_EN)
/* Slew Rate Control */
#define Al_SLW                    (* (reg8 *) Al__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Al_PRTDSI__CAPS_SEL       (* (reg8 *) Al__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Al_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Al__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Al_PRTDSI__OE_SEL0        (* (reg8 *) Al__PRTDSI__OE_SEL0) 
#define Al_PRTDSI__OE_SEL1        (* (reg8 *) Al__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Al_PRTDSI__OUT_SEL0       (* (reg8 *) Al__PRTDSI__OUT_SEL0) 
#define Al_PRTDSI__OUT_SEL1       (* (reg8 *) Al__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Al_PRTDSI__SYNC_OUT       (* (reg8 *) Al__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(Al__SIO_CFG)
    #define Al_SIO_HYST_EN        (* (reg8 *) Al__SIO_HYST_EN)
    #define Al_SIO_REG_HIFREQ     (* (reg8 *) Al__SIO_REG_HIFREQ)
    #define Al_SIO_CFG            (* (reg8 *) Al__SIO_CFG)
    #define Al_SIO_DIFF           (* (reg8 *) Al__SIO_DIFF)
#endif /* (Al__SIO_CFG) */

/* Interrupt Registers */
#if defined(Al__INTSTAT)
    #define Al_INTSTAT            (* (reg8 *) Al__INTSTAT)
    #define Al_SNAP               (* (reg8 *) Al__SNAP)
    
	#define Al_0_INTTYPE_REG 		(* (reg8 *) Al__0__INTTYPE)
	#define Al_1_INTTYPE_REG 		(* (reg8 *) Al__1__INTTYPE)
	#define Al_2_INTTYPE_REG 		(* (reg8 *) Al__2__INTTYPE)
	#define Al_3_INTTYPE_REG 		(* (reg8 *) Al__3__INTTYPE)
	#define Al_4_INTTYPE_REG 		(* (reg8 *) Al__4__INTTYPE)
	#define Al_5_INTTYPE_REG 		(* (reg8 *) Al__5__INTTYPE)
	#define Al_6_INTTYPE_REG 		(* (reg8 *) Al__6__INTTYPE)
	#define Al_7_INTTYPE_REG 		(* (reg8 *) Al__7__INTTYPE)
#endif /* (Al__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Al_H */


/* [] END OF FILE */
