/*******************************************************************************
* File Name: Al.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Al_ALIASES_H) /* Pins Al_ALIASES_H */
#define CY_PINS_Al_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"


/***************************************
*              Constants        
***************************************/
#define Al_0			(Al__0__PC)
#define Al_0_INTR	((uint16)((uint16)0x0001u << Al__0__SHIFT))

#define Al_1			(Al__1__PC)
#define Al_1_INTR	((uint16)((uint16)0x0001u << Al__1__SHIFT))

#define Al_2			(Al__2__PC)
#define Al_2_INTR	((uint16)((uint16)0x0001u << Al__2__SHIFT))

#define Al_3			(Al__3__PC)
#define Al_3_INTR	((uint16)((uint16)0x0001u << Al__3__SHIFT))

#define Al_4			(Al__4__PC)
#define Al_4_INTR	((uint16)((uint16)0x0001u << Al__4__SHIFT))

#define Al_5			(Al__5__PC)
#define Al_5_INTR	((uint16)((uint16)0x0001u << Al__5__SHIFT))

#define Al_6			(Al__6__PC)
#define Al_6_INTR	((uint16)((uint16)0x0001u << Al__6__SHIFT))

#define Al_7			(Al__7__PC)
#define Al_7_INTR	((uint16)((uint16)0x0001u << Al__7__SHIFT))

#define Al_INTR_ALL	 ((uint16)(Al_0_INTR| Al_1_INTR| Al_2_INTR| Al_3_INTR| Al_4_INTR| Al_5_INTR| Al_6_INTR| Al_7_INTR))

#endif /* End Pins Al_ALIASES_H */


/* [] END OF FILE */
