/*******************************************************************************
* File Name: Bank.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Bank_ALIASES_H) /* Pins Bank_ALIASES_H */
#define CY_PINS_Bank_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"


/***************************************
*              Constants        
***************************************/
#define Bank_0			(Bank__0__PC)
#define Bank_0_INTR	((uint16)((uint16)0x0001u << Bank__0__SHIFT))

#define Bank_1			(Bank__1__PC)
#define Bank_1_INTR	((uint16)((uint16)0x0001u << Bank__1__SHIFT))

#define Bank_2			(Bank__2__PC)
#define Bank_2_INTR	((uint16)((uint16)0x0001u << Bank__2__SHIFT))

#define Bank_3			(Bank__3__PC)
#define Bank_3_INTR	((uint16)((uint16)0x0001u << Bank__3__SHIFT))

#define Bank_4			(Bank__4__PC)
#define Bank_4_INTR	((uint16)((uint16)0x0001u << Bank__4__SHIFT))

#define Bank_INTR_ALL	 ((uint16)(Bank_0_INTR| Bank_1_INTR| Bank_2_INTR| Bank_3_INTR| Bank_4_INTR))

#endif /* End Pins Bank_ALIASES_H */


/* [] END OF FILE */
