/*******************************************************************************
* File Name: GP39.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_GP39_H) /* Pins GP39_H */
#define CY_PINS_GP39_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "GP39_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 GP39__PORT == 15 && ((GP39__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    GP39_Write(uint8 value);
void    GP39_SetDriveMode(uint8 mode);
uint8   GP39_ReadDataReg(void);
uint8   GP39_Read(void);
void    GP39_SetInterruptMode(uint16 position, uint16 mode);
uint8   GP39_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the GP39_SetDriveMode() function.
     *  @{
     */
        #define GP39_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define GP39_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define GP39_DM_RES_UP          PIN_DM_RES_UP
        #define GP39_DM_RES_DWN         PIN_DM_RES_DWN
        #define GP39_DM_OD_LO           PIN_DM_OD_LO
        #define GP39_DM_OD_HI           PIN_DM_OD_HI
        #define GP39_DM_STRONG          PIN_DM_STRONG
        #define GP39_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define GP39_MASK               GP39__MASK
#define GP39_SHIFT              GP39__SHIFT
#define GP39_WIDTH              1u

/* Interrupt constants */
#if defined(GP39__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in GP39_SetInterruptMode() function.
     *  @{
     */
        #define GP39_INTR_NONE      (uint16)(0x0000u)
        #define GP39_INTR_RISING    (uint16)(0x0001u)
        #define GP39_INTR_FALLING   (uint16)(0x0002u)
        #define GP39_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define GP39_INTR_MASK      (0x01u) 
#endif /* (GP39__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define GP39_PS                     (* (reg8 *) GP39__PS)
/* Data Register */
#define GP39_DR                     (* (reg8 *) GP39__DR)
/* Port Number */
#define GP39_PRT_NUM                (* (reg8 *) GP39__PRT) 
/* Connect to Analog Globals */                                                  
#define GP39_AG                     (* (reg8 *) GP39__AG)                       
/* Analog MUX bux enable */
#define GP39_AMUX                   (* (reg8 *) GP39__AMUX) 
/* Bidirectional Enable */                                                        
#define GP39_BIE                    (* (reg8 *) GP39__BIE)
/* Bit-mask for Aliased Register Access */
#define GP39_BIT_MASK               (* (reg8 *) GP39__BIT_MASK)
/* Bypass Enable */
#define GP39_BYP                    (* (reg8 *) GP39__BYP)
/* Port wide control signals */                                                   
#define GP39_CTL                    (* (reg8 *) GP39__CTL)
/* Drive Modes */
#define GP39_DM0                    (* (reg8 *) GP39__DM0) 
#define GP39_DM1                    (* (reg8 *) GP39__DM1)
#define GP39_DM2                    (* (reg8 *) GP39__DM2) 
/* Input Buffer Disable Override */
#define GP39_INP_DIS                (* (reg8 *) GP39__INP_DIS)
/* LCD Common or Segment Drive */
#define GP39_LCD_COM_SEG            (* (reg8 *) GP39__LCD_COM_SEG)
/* Enable Segment LCD */
#define GP39_LCD_EN                 (* (reg8 *) GP39__LCD_EN)
/* Slew Rate Control */
#define GP39_SLW                    (* (reg8 *) GP39__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define GP39_PRTDSI__CAPS_SEL       (* (reg8 *) GP39__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define GP39_PRTDSI__DBL_SYNC_IN    (* (reg8 *) GP39__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define GP39_PRTDSI__OE_SEL0        (* (reg8 *) GP39__PRTDSI__OE_SEL0) 
#define GP39_PRTDSI__OE_SEL1        (* (reg8 *) GP39__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define GP39_PRTDSI__OUT_SEL0       (* (reg8 *) GP39__PRTDSI__OUT_SEL0) 
#define GP39_PRTDSI__OUT_SEL1       (* (reg8 *) GP39__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define GP39_PRTDSI__SYNC_OUT       (* (reg8 *) GP39__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(GP39__SIO_CFG)
    #define GP39_SIO_HYST_EN        (* (reg8 *) GP39__SIO_HYST_EN)
    #define GP39_SIO_REG_HIFREQ     (* (reg8 *) GP39__SIO_REG_HIFREQ)
    #define GP39_SIO_CFG            (* (reg8 *) GP39__SIO_CFG)
    #define GP39_SIO_DIFF           (* (reg8 *) GP39__SIO_DIFF)
#endif /* (GP39__SIO_CFG) */

/* Interrupt Registers */
#if defined(GP39__INTSTAT)
    #define GP39_INTSTAT            (* (reg8 *) GP39__INTSTAT)
    #define GP39_SNAP               (* (reg8 *) GP39__SNAP)
    
	#define GP39_0_INTTYPE_REG 		(* (reg8 *) GP39__0__INTTYPE)
#endif /* (GP39__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_GP39_H */


/* [] END OF FILE */
