/*******************************************************************************
* File Name: GP5.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_GP5_ALIASES_H) /* Pins GP5_ALIASES_H */
#define CY_PINS_GP5_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"


/***************************************
*              Constants        
***************************************/
#define GP5_0			(GP5__0__PC)
#define GP5_0_INTR	((uint16)((uint16)0x0001u << GP5__0__SHIFT))

#define GP5_1			(GP5__1__PC)
#define GP5_1_INTR	((uint16)((uint16)0x0001u << GP5__1__SHIFT))

#define GP5_2			(GP5__2__PC)
#define GP5_2_INTR	((uint16)((uint16)0x0001u << GP5__2__SHIFT))

#define GP5_3			(GP5__3__PC)
#define GP5_3_INTR	((uint16)((uint16)0x0001u << GP5__3__SHIFT))

#define GP5_4			(GP5__4__PC)
#define GP5_4_INTR	((uint16)((uint16)0x0001u << GP5__4__SHIFT))

#define GP5_INTR_ALL	 ((uint16)(GP5_0_INTR| GP5_1_INTR| GP5_2_INTR| GP5_3_INTR| GP5_4_INTR))

#endif /* End Pins GP5_ALIASES_H */


/* [] END OF FILE */
