#include "project.h"

#include <ff.h>
#include <diskio.h>

#include <stdio.h>

#define print(a) {while (!USBUART_CDCIsReady()) {;} USBUART_PutString(a);}
#define uprintf(a) print(a)
#define printf(a,...) { while (!USBUART_CDCIsReady()) {;} sprintf(buffer,a,__VA_ARGS__); USBUART_PutString(buffer); }
#define status(a,b) { sprintf(buffer,"%s:%02x\n\r",a,b); while (!USBUART_CDCIsReady()) {;} USBUART_PutString(buffer); }
#define lstatus(a,b) { sprintf(buffer,"%s:%08lx\n\r",a,b); while (!USBUART_CDCIsReady()) {;} USBUART_PutString(buffer); }
#define uprinth(a) { sprintf(buffer,"%02x",(uint8)(a)); while (!USBUART_CDCIsReady()) {;} USBUART_PutString(buffer); }
#define uprintb(a) { sprintf(buffer,"b%s%s",bin2str[(a>>4)],bin2str[(a)&15]); while (!USBUART_CDCIsReady()) {;} USBUART_PutString(buffer); }
#define uprintb2(a) { sprintf(buffer,"%s%s",bin2str[(a>>4)],bin2str[(a)&15]); while (!USBUART_CDCIsReady()) {;} USBUART_PutString(buffer); }

#define key_avail (ps2_available()||USBUART_GetCount())
#define key_read {if (ps2_available()) {kbuf[0]=ps2_read();} \
                  if (USBUART_GetCount()) {USBUART_GetData(kbuf,USBUART_GetCount());}}

typedef struct _sbc {
    void (*main_loop)(void);
    void (*interrupt)(void);
    char sbc_bootfile[80];
    char sbc_dir[80];
    uint32 f_offset;
    uint16 loadaddr;
    uint16 f_size;
    char sbc_name[80];
} sbc;
                
#ifndef MAIN

extern const char *bin2str[16];
    
extern char buffer[60];
extern char rbuf[65],wbuf[65],*ubuf,*pbuf;
extern uint8 uptr,kbuf[8];

extern volatile uint8 io_int,io_port,io_data,io_ctrl;
extern volatile uint8 ink,key,obusy;

#define SD_NINIT 0xFF
#define SD_IDLE  0
#define SD_OPEN  1
#define SD_READ  10
#define SD_WRITE 20
#define SD_PREWRITE 21

extern FATFS fatFs;
extern uint8 resultF;
extern FIL    fileO;
extern uint32 Rw_Ptr;
extern char   rw_buf[512];
extern uint rdbytes;

extern uint32 cpm_offset;
extern volatile uint8 sdcard_op;

//extern char filename[80];
//extern uint32 f_offset;
//extern uint16 f_size;
//extern char emul_name[80];

//extern void (*interrupt)(void);
//extern void (*main_loop)(void);

extern sbc SBC;

#define CleanRestart() {}

#endif

void GrantModeInit(void);
void RC2014ModeInit(void);
void RCSIOModeInit(void);
void Cpm3ModeInit(void);
void PacmanModeInit(void);
void S100ModeInit(void);
void ZX81ModeInit(void);
void MBC2ModeInit(void);

void sram_test(void);
void sram_zero(void);
void sram_sendfile(void);
void sram_read(void);

void vga_init(void);
void vga_print(char *ptr);

void ps2_init(void);
uint8 ps2_available(void);
uint8 ps2_read(void);

