/* GRANT based CPM3 Specific Emulation Part */

#include "common.h"

CY_ISR(Cpm3ModeISR)
{
    //IORQn_ClearInterrupt();
    IORQn_INTSTAT;              // Clear on Read
    
    if ((M1_PS&M1_MASK)==0) {INTn_Write(1); Control_Control|=1; return; }
    
    io_ctrl=*(uint8*)CYREG_PRT0_PS;
    
    if ((io_ctrl&0x02)==0)      // Write IO
    {
        io_port=Al_PS; io_data=D_PS;
        
        switch (io_port)
        {
            case 0x81:
                ubuf[uptr++]=io_data;
                break;

            case 0x10:
                cpm_offset=(cpm_offset&0xFFFF8000)|(io_data<<9);   //SECT (0..63) -- 0->32K
                break;
            case 0x11:
                cpm_offset=(cpm_offset&0xFF807FFF)|(io_data<<15);  //TRK1 (0..255) -- 32K->8M
                break;
            //case 0x12:
            //cpm_offset=(cpm_offset&0xFFFFFF00)|(0<<25);  //TRK2 (0) --
            //  break;
            case 0x13:
                cpm_offset=(cpm_offset&0xF87FFF00)|(io_data<<23);  //DSK (0..15) -- 8M->128M
                break;
            case 0x14:
                if (io_data==0x2)
                { //lstatus("Read @",cpm_offset);
                sdcard_op=SD_READ;            
                }
                else if (io_data==0x1)
                { //lstatus("Pre_Write @",cpm_offset);
                Rw_Ptr=0; 
                }
                break;
            case 0x15:
                if (Rw_Ptr>=512) {lstatus("EoB Writing byte:",Rw_Ptr);}
                rw_buf[Rw_Ptr++]=io_data;
                if (Rw_Ptr==512) { 
                    sdcard_op=SD_WRITE;
                    //lstatus("Writing @",cpm_offset);
                }
                break;
                
            case 0xA8:
                if (sdcard_op==SD_NINIT) sdcard_op=SD_OPEN;
                //if (bank!=data) status("Bank",data);
                //bank=data;
                //Control_Control&=0xF9;                 
                //Control_Control|=(data<<1);
                break;
        
            default:
                io_int=1;
        }
    }
    else if ((io_ctrl&0x01)==0)     // Read IO
    { 
        io_port=Al_PS;
        
        switch (io_port)
        {
            case 0x80:
                D_DR=4|(ink<<1);break;
            case 0x81:
                D_DR=key;ink=0;break;

            case 0x14:
                D_DR=(sdcard_op==SD_IDLE)?0x00:0x01;
                break;          
            case 0x15:
                D_DR=rw_buf[Rw_Ptr++];
                if (Rw_Ptr>rdbytes) { //print("EoB");
                                      Rw_Ptr=0;}
                break;
                
            default:
                io_int=1;
        }
    }
    else
    {
        io_port=Al_PS; io_data=D_PS;
        io_int=1;
    }
    
    Control_Control|=1;
}

void Cpm3ModeLoop(void)
{
    uint8 i,debug;
    uint8 buf[64];
    char *tbuf,*pbuf;

    debug=0;

    ink=0;key=0;ubuf=wbuf;pbuf=rbuf;uptr=0;
    sdcard_op=SD_NINIT;
    
    Control_Control|=1;     /* Reset Wait */
    CyDelay(1);RESETn_Write(1);
    do
    {
        if (debug){
            uprinth(Ah_PS);uprinth(Al_PS);uprintf(" ");uprinth(D_PS);uprintf(" ");uprinth(*(uint8*)CYREG_PRT0_PS);
            uprintf("\r");
        }
        
        if (io_int) {  IOint_Disable();
                       if ((io_ctrl&0x01)==0) {uprintf("\r\nInt : R");uprinth(io_port);uprinth(io_data);uprintf("\n\r");}
                       else if ((io_ctrl&0x02)==0) {uprintf("\r\nInt : W");uprinth(io_port);uprinth(io_data);uprintf("\n\r");}
                       else {uprintf("\r\nInt : ?");uprinth(io_ctrl);uprinth(io_port);uprinth(io_data);uprintf("\n\r");}
                       debug=1;
                       io_int=0;
                       IOint_Enable();
                    }
        
        if (sdcard_op==SD_READ) {
          resultF=f_lseek(&fileO,cpm_offset);
          if (resultF != RES_OK) {print("Read Seek not OK\n\r");}
          resultF=f_read(&fileO,rw_buf,512,&rdbytes); 
          if (resultF != RES_OK) {print("Read not OK\n\r");}
          Rw_Ptr=0; 
          sdcard_op=SD_IDLE;
        }
        if (sdcard_op==SD_WRITE) {            
          resultF=f_lseek(&fileO,cpm_offset);
          if (resultF != RES_OK) {print("Wr Seek not OK\n\r");}
          resultF=f_write(&fileO,rw_buf,512,&rdbytes);
          if (resultF != RES_OK) {print("Wr not OK\n\r");}
          Rw_Ptr=0;
          sdcard_op=SD_IDLE;
        }
        if (sdcard_op==SD_OPEN) {            
          resultF=f_open(&fileO,"cpm3.bin",FA_READ|FA_WRITE);
          //if (resultF == RES_OK) { print("cpm.bin opened for RW Ok\n\r");
          //lstatus("File size ",f_size(&fileO));}
          sdcard_op=SD_IDLE;
        }

        if (uptr&&USBUART_CDCIsReady()) {IOint_Disable();ubuf[uptr]=0;
                                         tbuf=ubuf;ubuf=pbuf;pbuf=tbuf;
                                         uptr=0;IOint_Enable();
                                         uprintf(pbuf);}

        if ((i=USBUART_GetCount())) {USBUART_GetData(buf,i);ink=1; key=buf[0]; 
                                     //status("\n\rIntVec:",SIO_B[2]);
                                     INTn_Write(0); }
    } while (key!='~');
}

sbc CPM3={
    .sbc_dir="cpm3",
    .sbc_bootfile="boot3.bin",
    .sbc_name="CPM3 Mode",
    .f_offset=0, .f_size=0, .loadaddr=0,
    .interrupt=Cpm3ModeISR,
    .main_loop=Cpm3ModeLoop
};

void Cpm3ModeInit(void)
{
    CleanRestart();
    
    SBC=CPM3;
}

