/* RC2014 Specific Emulation Part */

#include "common.h"

uint8 fchoice=0;
uint8 diskset,disksel,sect;
uint16 track;

uint8 opcode=0,kstate;
uint16 iobytecnt=0;

      // Currently defined Opcodes for I/O write operations:
      //
      //   Opcode     Name            Exchanged bytes
      // -------------------------------------------------
      // Opcode 0x00  USER LED        1
      // Opcode 0x01  SERIAL TX       1
      // Opcode 0x03  GPIOA Write     1
      // Opcode 0x04  GPIOB Write     1
      // Opcode 0x05  IODIRA Write    1
      // Opcode 0x06  IODIRB Write    1
      // Opcode 0x07  GPPUA Write     1
      // Opcode 0x08  GPPUB Write     1
      // Opcode 0x09  SELDISK         1
      // Opcode 0x0A  SELTRACK        2
      // Opcode 0x0B  SELSECT         1  
      // Opcode 0x0C  WRITESECT       512
      // Opcode 0x0D  SETBANK         1
      // Opcode 0xFF  No operation    1

      // Currently defined Opcodes for I/O read operations:
      //
      //   Opcode     Name            Exchanged bytes
      // -------------------------------------------------
      // Opcode 0x80  USER KEY        1
      // Opcode 0x81  GPIOA Read      1
      // Opcode 0x82  GPIOB Read      1
      // Opcode 0x83  SYSFLAGS        1
      // Opcode 0x84  DATETIME        7
      // Opcode 0x85  ERRDISK         1
      // Opcode 0x86  READSECT        512
      // Opcode 0x87  SDMOUNT         1
      // Opcode 0xFF  No operation    1


void MBC2ModeLoop(void)
{
    uint8 i,debug;
    uint8 buf[64];
    char *tbuf,*pbuf;

    debug=0;kstate=0;
    ink=0;key=0;ubuf=wbuf;pbuf=rbuf;uptr=0;

    Control_Control|=1;     /* Reset Wait */
    CyDelay(1);RESETn_Write(1);
    do
    {
        if (debug){
            uprinth(Ah_PS);uprinth(Al_PS);uprintf(" ");uprinth(D_PS);uprintf(" ");uprinth(*(uint8*)CYREG_PRT0_PS);
            uprintf("\r");
        }
        
        if (io_int) {  IOint_Disable();
                       if ((io_ctrl&0x01)==0) {uprintf("\r\nInt : R");}
                       else if ((io_ctrl&0x02)==0) {uprintf("\r\nInt : W");}
                       else {uprintf("\r\nInt : ?");uprinth(io_ctrl);}
                       //debug=1;
                       uprinth(io_port);uprinth(io_data);uprintf("-");
                       uprinth(opcode);uprinth(iobytecnt);uprintf("\n\r");
                       io_int=0;
                       IOint_Enable();
                    }

        if (uptr&&USBUART_CDCIsReady()) {IOint_Disable();ubuf[uptr]=0;
                                         tbuf=ubuf;ubuf=pbuf;pbuf=tbuf;
                                         uptr=0;IOint_Enable();
                                         uprintf(pbuf);
                                        }
        
        if ((i=USBUART_GetCount())) {USBUART_GetData(buf,i); key=buf[0]; ink=1; 
             if (kstate && (key=='d')) {    
                // CLK driven by DR, not by hardware Clock_1 (Clock_1_Stop useless ?)
                Clock_1_Stop();   
                *(uint8*)CYREG_PRT12_BYP&=0xDF;         // CLK on P12[5]
                debug=1;
            }
            
            if (kstate && (key=='x')) break;
            if (kstate && (key=='m')) {RESETn_Write(0);CyDelay(10);sram_read();}
        
            if (key=='~') {kstate=1;} else {kstate=0;}

        INTn_Write(0); }
    } while (1);
    
}

char filename[80];
uint8 filebuf[512];

CY_ISR(MBC2ModeISR)
{
    //IORQn_ClearInterrupt();
    IORQn_INTSTAT;              // Clear on Read
    
    if ((M1_PS&M1_MASK)==0) {D_DR=0x12; INTn_Write(1); Control_Control|=1; return; }
    
    io_ctrl=*(uint8*)CYREG_PRT0_PS;
    
    if ((io_ctrl&0x02)==0)      // Write IO
    {
        io_port=Al_PS; io_data=D_PS;
        
        switch (io_port)
        {
            case 0x01:
                opcode=io_data; iobytecnt=0; break;
            case 0x00:
                switch (opcode)
                {
                    case 0x01:
                        ubuf[uptr++]=io_data; break;
                    case 0x09:
                        disksel=io_data;
                        sprintf(filename,"DS%01dN%02d.DSK",diskset,disksel);
                        resultF=f_open(&fileO,filename,FA_READ|FA_WRITE);
                        //sprintf(ubuf+uptr,"%s",filename);uptr+=10;
                        break;
                    case 0x0a:
                        if (!iobytecnt) track=io_data;
                            else        track|=(io_data<<8);
                        iobytecnt++; break;
                    case 0x0b:
                        sect=io_data; break;
                    case 0x0c:
                        filebuf[iobytecnt]=io_data;
                        iobytecnt++;
                        if (iobytecnt==512) {f_lseek(&fileO,(uint32)(((track<<5)|sect)<<9));
                                             f_write(&fileO,filebuf,512,&rdbytes);}
                        break;
                    case 0x0d:
                        // Parameter = OS Bank (0-2) Lower 32k : 0->0x00000-0x07FFF    
                        //                                       1->0x10000-0x17FFF
                        //                                       2->0x18000-0x1FFFF
                        if (io_data==0) {MPURR0_Control=0x00; MPURR1_Control=0x01;}
                        if (io_data==1) {MPURR0_Control=0x04; MPURR1_Control=0x05;}
                        if (io_data==2) {MPURR0_Control=0x06; MPURR1_Control=0x07;}
                        break;
                    default:
                        io_int=1;
                }
                break;
            default:
                io_int=1;
        }
    }
    else if ((io_ctrl&0x01)==0)     // Read IO
    { 
        io_port=Al_PS;
        
        switch (io_port)
        {
            case 0x01:
                if (ink) D_DR=key;
                    else D_DR=0xFF;
                ink=0;break;
            case 0x00:
                switch (opcode)
                {
                    case 0x83:
                        D_DR=0; break;  // No autoexec/date support
                    case 0x85:          // disk error
                        D_DR=0; break;
                    case 0x86:          // read sect - 1 byte
                        if (iobytecnt==0)
                         {
                          //sprintf(ubuf+uptr,"Rd%08lx",(uint32)(track<<16) | sect);uptr+=10;
                          f_lseek(&fileO,(uint32)(((track<<5)|sect)<<9));
                          f_read(&fileO,filebuf,512,&rdbytes);}
                        D_DR=filebuf[iobytecnt];
                        iobytecnt++;
                        break;
                    case 0x87:          // sd mount
                        D_DR=0; break;
                    default:
                        io_int=1;
                }
                break;
            default:
                io_int=1;
        }
    }
    else
    {
        io_port=Al_PS; io_data=D_PS;
        io_int=1;
    }
    
    Control_Control|=1;
}

sbc MBC2={
    .sbc_name="MBC2",            
    .sbc_dir="mbc2",
    .sbc_bootfile="basic47.bin",
    .f_offset=0, .f_size=0, .loadaddr=0,
    .interrupt=MBC2ModeISR,
    .main_loop=MBC2ModeLoop
};

/*
#define   BASICFN       "BASIC47.BIN"
#define   FORTHFN       "FORTH13.BIN"
#define   CPMFN         "CPM22.BIN"
#define   QPMFN         "QPMLDR.BIN"
#define   CPM3FN        "CPMLDR.COM"      // CP/M 3 CPMLDR.COM loader
#define   AUTOFN        "AUTOBOOT.BIN"
#define   Z80DISK       "DSxNyy.DSK"      // Generic Z80 disk name (from DS0N00.DSK to DS9N99.DSK)
#define   DS_OSNAME     "DSxNAM.DAT"      // File with the OS name for Disk Set "x" (from DS0NAM.DAT to DS9NAM.DAT)
#define   BASSTRADDR    0x0000            // Starting address for the stand-alone Basic interptreter
#define   FORSTRADDR    0x0100            // Starting address for the stand-alone Forth interptreter
#define   CPM22CBASE    0xD200            // CBASE value for CP/M 2.2
#define   CPMSTRADDR    (CPM22CBASE - 32) // Starting address for CP/M 2.2
#define   QPMSTRADDR    0x80              // Starting address for the QP/M 2.71 loader
#define   CPM3STRADDR   0x100             // Starting address for the CP/M 3 loader
#define   AUTSTRADDR    0x0000            // Starting address for the AUTOBOOT.BIN file
*/

void MBC2ModeInit(void)
{
    CleanRestart();
    
    MBC2.loadaddr=0;
    if (fchoice==0) {sprintf(MBC2.sbc_bootfile,"basic47.bin"); }
    if (fchoice==1) {sprintf(MBC2.sbc_bootfile,"forth13.bin"); MBC2.loadaddr=0x100; }
    if (fchoice==2) {sprintf(MBC2.sbc_bootfile,"cpm22.bin"); MBC2.loadaddr=0xd200-32; diskset=0;}
    if (fchoice==3) {sprintf(MBC2.sbc_bootfile,"qpmldr.bin"); MBC2.loadaddr=0x80; diskset=1;}
    if (fchoice==4) {sprintf(MBC2.sbc_bootfile,"cpmldr.com"); MBC2.loadaddr=0x100; diskset=2;}
   
    if (fchoice==5) {sprintf(MBC2.sbc_bootfile,"autoboot.bin"); }
    fchoice++; if (fchoice==6) fchoice=0;
    SBC=MBC2;
}
