#include "common.h"

CY_ISR(PacmanModeISR)
{
    //IORQn_ClearInterrupt();
    IORQn_INTSTAT;              // Clear on Read
    
    if ((M1_PS&M1_MASK)==0) {INTn_Write(1); Control_Control|=1; return; }
    
    io_ctrl=*(uint8*)CYREG_PRT0_PS;
    
    if ((io_ctrl&0x02)==0)      // Write IO
    {
        io_port=Al_PS; io_data=D_PS;
        
        switch (io_port)
        {
            default:
                io_int=1;
        }
    }
    else if ((io_ctrl&0x01)==0)     // Read IO
    { 
        io_port=Al_PS;
        
        switch (io_port)
        {
   
            default:
                io_int=1;
        }
    }
    else
    {
        io_port=Al_PS; io_data=D_PS;
        io_int=1;
    }
    
    Control_Control|=1;
}

void PacmanModeLoop(void)
{
    uint8 i,debug;
    uint8 buf[64];
    char *tbuf,*pbuf;

    debug=1;
    Clock_1_SetDivider(19999);
    
    ink=0;key=0;ubuf=wbuf;pbuf=rbuf;uptr=0;

    Control_Control|=1;     /* Reset Wait */
    CyDelay(1);RESETn_Write(1);
    do
    {
        if (debug){
            uprinth(Ah_PS);uprinth(Al_PS);uprintf(" ");uprinth(D_PS);uprintf(" ");uprinth(*(uint8*)CYREG_PRT0_PS);
            uprintf("\n\r");
        }
        
        if (io_int) {  IOint_Disable();
                       if ((io_ctrl&0x01)==0) {uprintf("\r\nInt : R");uprinth(io_port);uprinth(io_data);uprintf("\n\r");}
                       else if ((io_ctrl&0x02)==0) {uprintf("\r\nInt : W");uprinth(io_port);uprinth(io_data);uprintf("\n\r");}
                       else {uprintf("\r\nInt : ?");uprinth(io_ctrl);uprinth(io_port);uprinth(io_data);uprintf("\n\r");}
                       debug=1;
                       io_int=0;
                       IOint_Enable();
                    }
        
        if (uptr&&USBUART_CDCIsReady()) {IOint_Disable();ubuf[uptr]=0;
                                         tbuf=ubuf;ubuf=pbuf;pbuf=tbuf;
                                         uptr=0;IOint_Enable();
                                         uprintf(pbuf);}

        if ((i=USBUART_GetCount())) {USBUART_GetData(buf,i);ink=1; key=buf[0];
                                     INTn_Write(0);}
    } while (key!='~');
}

sbc PacMan={
    .sbc_dir="pacman",
    .sbc_bootfile="pacman.bin",
    .sbc_name="Pacman Test Mode",
    .f_offset=0, .f_size=0, .loadaddr=0,
    .interrupt=PacmanModeISR,
    .main_loop=PacmanModeLoop
};

void PacmanModeInit(void)
{
    CleanRestart();
    
    SBC=PacMan;
}