#include "common.h"

uint8 PA,PB,PC,Cfg;
uint8 dta1out,dta2out;
uint8 CylMSB,CylLSB,Sector;

#define OBUSY 0x00
#define OIDLE 0x04
#define INONE  0x00
#define IAVAIL 0x01

CY_ISR(S100ModeISR)
{
    //IORQn_ClearInterrupt();
    IORQn_INTSTAT;              // Clear on Read
    
    //if ((M1_PS&M1_MASK)==0) {INTn_Write(1); Control_Control|=1; return; }
    
    io_ctrl=*(uint8*)CYREG_PRT0_PS;
    
    if ((io_ctrl&0x02)==0)      // Write IO
    {
        io_port=Al_PS; io_data=D_PS;
        
        switch (io_port)
        {
                            //8255 Write
            case 0x30:      //PortA
                PA=io_data;
                break;
            case 0x31:      //PortB
                PB=io_data;
                break;
            case 0x32:      //PortC (Rst,Rd,Wr,Cs1,Cs0,A2,A1,A0)
                PC=io_data; 
                if (PC&0x40) // Read
                 {
                    // IDE Status Register:
                    //  bit 7: Busy	1=busy, 0=not busy
                    //  bit 6: Ready 1=ready for command, 0=not ready yet
                    //  bit 5: DF	1=fault occured insIDE drive
                    //  bit 4: DSC	1=seek complete
                    //  bit 3: DRQ	1=data request ready, 0=not ready to xfer yet
                    //  bit 2: CORR	1=correctable error occured
                    //  bit 1: IDX	vendor specific
                    //  bit 0: ERR	1=error occured

                    if ((PC&0x7)==7) { /*status*/
                                       dta1out=((sdcard_op==SD_IDLE) || (sdcard_op==SD_PREWRITE))?0x58:0xD8; 
                                       break;
                                     }
                    if ((PC&0x7)==0) { dta1out=rw_buf[Rw_Ptr++];
                                       dta2out=rw_buf[Rw_Ptr++]; 
                                       break;
                                     }
                    break;
                 }
                if (PC&0x20) // Write
                 {
                    if ((PC&0x7)==6 ) {sdcard_op=SD_OPEN; break;}
                    if ((PC&0x7)==5 ) {CylMSB=PA; break;}  // always '0' ?
                    if ((PC&0x7)==4 ) {CylLSB=PA; break;}
                    if ((PC&0x7)==3 ) {Sector=PA; break;}
                    if ((PC&0x7)==7 ) {if (PA==0x20) {cpm_offset=(CylMSB<<25)|
                                                                 (CylLSB<<17)|
                                                                 (Sector<<9);
                                                      sdcard_op=SD_READ;break;}
                                       if (PA==0x30) {cpm_offset=(CylMSB<<25)|
                                                                 (CylLSB<<17)|
                                                                 (Sector<<9);
                                                      sdcard_op=SD_PREWRITE; Rw_Ptr=0;break;}
                                      }
                    if ((PC&0x7)==0 ) {
                                       if (sdcard_op==SD_PREWRITE) { rw_buf[Rw_Ptr++]=PA;
                                                                     rw_buf[Rw_Ptr++]=PB; 
                                                                     if (Rw_Ptr==512) {sdcard_op=SD_WRITE;}
                                                                     break;
                                                                   }
                                      }
                    break;
                 }
                break;
            case 0x33:      //Cfg - not checked 0x80 or 0x92 'a priori'
                Cfg=io_data;break;
                
            case 0x34:
                break;
            
            case 0xA1:
                break;
            case 0xA3:
                ubuf[uptr++]=io_data; break;
                
            case 0xD2:      //MPURR0 (Bank 0000-3FFF)
                MPURR0_Write(io_data>>2); break;      
            case 0xD3:      //MPURR1 (Bank 4000-7FFF)
                MPURR1_Write(io_data>>2); break;
            
            default:
                io_int=1;
        }
    }
    else if ((io_ctrl&0x01)==0)     // Read IO
    { 
        io_port=Al_PS;
        
        switch (io_port)
        {
            case 0x30:
                D_DR=dta1out;
                break;
            case 0x31:
                D_DR=dta2out;
                break;
                
            case 0xA1:
                D_DR=obusy|ink; break;
            case 0xA3:
                D_DR=key;ink=INONE;break;
                
            default:
                io_int=1;
        }
    }
    else
    {
        io_port=Al_PS; io_data=D_PS;
        io_int=1;
    }
    
    Control_Control|=1;
}

void S100ModeLoop(void)
{
    uint8 debug=0,kstate=0,clk=0,cycle=0;
    
    ink=INONE;key=0;
    ubuf=wbuf;pbuf=rbuf;uptr=0;
    obusy=OIDLE;

    Control_Control|=1;     /* Reset Wait */
    CyDelay(1);RESETn_Write(1);
    do
    {
        if (debug){
            
            clk^=1;
            CLK_Write(clk); 
            
            if (clk) {
             if (((*(uint8*)CYREG_PRT12_PS)&0x40)==0) {
              cycle++;
              if (cycle==2)
              {
              uprinth(Ah_PS);uprinth(Al_PS);uprintf(" ");
              uprinth(D_PS);uprintf(" ");uprinth(*(uint8*)CYREG_PRT0_PS);            
              uprintf("\n\r");
              }
             }
             else cycle=0;
            }
        }
#if 0        
        if (io_int) {  IOint_Disable();
                       if ((io_ctrl&0x01)==0) {uprintf("\r\nInt : R");uprinth(io_port);uprinth(io_data);uprintf("\n\r");}
                       else if ((io_ctrl&0x02)==0) {uprintf("\r\nInt : W");uprinth(io_port);uprinth(io_data);uprintf("\n\r");}
                       else {uprintf("\r\nInt : ?");uprinth(io_ctrl);uprinth(io_port);uprinth(io_data);uprintf("\n\r");}
                       debug=1;
                       io_int=0;
                       IOint_Enable();
                    }
#endif     
        if (sdcard_op==SD_READ) {
          //lstatus("Read ",cpm_offset);
          resultF=f_lseek(&fileO,cpm_offset);
          if (resultF != RES_OK) {print("Read Seek not OK\n\r");}
          resultF=f_read(&fileO,rw_buf,512,&rdbytes); 
          if (resultF != RES_OK) {print("Read not OK\n\r");}
          Rw_Ptr=0; 
          sdcard_op=SD_IDLE;
        }
        if (sdcard_op==SD_WRITE) { 
          //lstatus("Write ",cpm_offset);
          resultF=f_lseek(&fileO,cpm_offset);
          if (resultF != RES_OK) {print("Wr Seek not OK\n\r");}
          resultF=f_write(&fileO,rw_buf,512,&rdbytes);
          if (resultF != RES_OK) {print("Wr not OK\n\r");}
          Rw_Ptr=0;
          sdcard_op=SD_IDLE;
        }
        if (sdcard_op==SD_OPEN) {            
          resultF=f_open(&fileO,"s100cpm3.bin",FA_READ|FA_WRITE);
          if (resultF == RES_OK) { print("s100cpm3.bin opened for RW Ok\n\r");
          lstatus("File size ",f_size(&fileO));}
          sdcard_op=SD_IDLE;
        }
        
        if (uptr&&USBUART_CDCIsReady()) {char *tbuf;
                                         IOint_Disable();ubuf[uptr]=0;
                                         tbuf=ubuf;ubuf=pbuf;pbuf=tbuf;
                                         uptr=0;IOint_Enable();
                                         obusy=OBUSY;
                                         uprintf(pbuf);vga_print(pbuf);
                                         obusy=OIDLE;}
        
        if (key_avail) {key_read; key=kbuf[0]; ink=IAVAIL;
        
            if (kstate && (key=='d')) {    
                // CLK driven by DR, not by hardware Clock_1 (Clock_1_Stop useless ?)
                Clock_1_Stop();   
                *(uint8*)CYREG_PRT12_BYP&=0xDF;         // CLK on P12[5]
                debug=1;
            }
            
            if (kstate && (key=='x')) break;
            if (kstate && (key=='m')) {RESETn_Write(0);CyDelay(10);sram_read();}
        
            if (key=='~') {kstate=1;} else {kstate=0;}
        }
    } while (1);
}

sbc S100={
    .sbc_dir="s100",
    .sbc_bootfile="s100ldr.bin",
    .sbc_name="S100 SBC Mode",
    .f_offset=0, .f_size=0, .loadaddr=0,
    .interrupt=S100ModeISR,
    .main_loop=S100ModeLoop
};

void S100ModeInit(void)
{
    CleanRestart();
    SBC=S100;
}